from requests import get, post
from bs4 import BeautifulSoup
from json import loads, dumps

def Converter(url : str, sp_at : str, sp_uid : str):

    headers = {
        "Accept" : "application/json",
        "Content-Type" : "application/json",
        "Authorization" : f"Bearer {sp_at}" 
    }

    amd : dict = loads(BeautifulSoup(get(url, headers={"User-Agent" : "Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:100.0) Gecko/20100101 Firefox/100.0"}).text, "html.parser").find("script", attrs={"name" : "schema:musicPlaylist", "type" : "application/ld+json"}).text)

    uris : list = []
    skipped : list = []

    print(f"\n\nStarted converting {len(amd['track'])} tracks from Apple Music.......\n")

    for track in amd["track"]:
        smd : dict = get(f"https://api.spotify.com/v1/search?q={track.get('name')}&type=track&limit=1", headers=headers).json()
        
        if smd["tracks"]["items"]:
            uris.append(smd["tracks"]["items"][0]["uri"])
        
        else:
            skipped.append(track.get("name"))

    data : dict = {
        "name": amd.get("name"),
        "description": amd.get("description"),
        "public": False
    }

    req : dict = post(f"https://api.spotify.com/v1/users/{sp_uid}/playlists", headers=headers, data=dumps(data)).json()

    if req["id"]:
        post(f"https://api.spotify.com/v1/playlists/{req['id']}/tracks?uris={','.join(uris)}", headers=headers).json()

        print(f"Playlist created with name: '{req['name']}'\n")

        if skipped:
            print(f"Skipped {len(skipped)} Tracks:")
            for i in skipped:
                print(i)
            print("\n...............................\n")

    else:
        print("Something went wrong!")